/*--------------- COPYRIGHT ------------------------
| INRA - Unit MIA de Jouy en Josas                |
--------------------------------------------------*/

/*--------------- IDENTIFICATION PRODUIT -----------
| Derniere mise a jour : 15 Jan 2006               |
| Role                 : Mesure du temps           |
|                        d'excution               |
--------------------------------------------------*/
/////////////////////////////////////////////////////////

#include "calitypes.h"
#ifdef GETRUSAGE
#include <sys/time.h>
#include <sys/resource.h>
#endif

#ifdef TIMES
#include <sys/times.h>
#include <sys/types.h>
#ifdef __ultrix
#define _POSIX_SOURCE
#endif // __ultrix
#include <time.h>
#ifdef __ultrix
#undef _POSIX_SOURCE
#endif // __ultrix
#endif



/////////////////////////////////////////////////////////
long int
timing ()
{
  long int t = 0;
#ifdef GETRUSAGE
  struct rusage info;
  struct timeval *user_t = &(info.ru_utime), *sys_t = &(info.ru_stime);

  getrusage (0, &info);

  // convert (seconds,microseconds) to milliseconds
  t += user_t->tv_sec * 1000 + user_t->tv_usec / 1000;
  t += sys_t->tv_sec * 1000 + sys_t->tv_usec / 1000;
#endif
#ifdef TIMES
  struct tms tms;
  times (&tms);

  t = tms.tms_utime + tms.tms_stime;	// this is in  clock_ticks 
  // conversion of clock_ticks to milliseconds
  t = (long) ((real) (t) * (real) (1000) / (real) (100));
  //  printf("clocks_per_sec : %ld\n", CLOCKS_PER_SEC);
#endif

  return t;
}

/////////////////////////////////////////////////////////
