###############################################
# Calcul de la distance minimale entre les poly
# d'un objet Polygons, ceux-ci tant supposs convexes.
###############################################

#################################################

if (!isGeneric("distMin"))
	setGeneric("distMin", function(x)
		standardGeneric("distMin"))
# ____________________________________
# Cration de la dfinition par dfaut 'distMin'
# ____________________________________
distMin.default = function(x)
  {
  if (!inherits(x,"Polygons"))
    stop("This function is valid only on a 'Polygons' object.")
else
distMin.Polygons(x)
	
  }
# -----------------------------------------------
# Cration de la dfinition specialisee a Polygons
# -----------------------------------------------

distMin.Polygons=function(x)
{

# La matrice de retour:
npoly = length(slot(x, "Polygons"))
    distances = matrix(NA, ncol = npoly, nrow = npoly)


# La matrice inclus[i,j] = un code selon que le poly j est inclus,
#  chevauche, contient, est distinct de i
# est NA si i ou j n'est pas convex
inclus = inConvex(x)

for (i in 1:npoly)
{
unpoly = slot(x, "Polygons")[[i]]

for (j in i:npoly)
{
# Eliminer les polys non convexes
if (is.na(inclus[i,j]))
  next

# La distance d'un poly vers lui-mme est 0
# ainsi que celles entre polys non distincts
# (1 poly inclus dans l'autre et qui se chevauchent)
if ((i==j) || (inclus[i,j]!="D"))
 {
distances[i,j] = 0.0
distances[j,i] = 0.0
next
}


deuxpoly = slot(x, "Polygons")[[j]]
# mettre les coordonnees counterclock si elles ne le sont pas
# i.e si ce n'est pas un trou
p1 = putAntiClock(unpoly)
p2 = putAntiClock(deuxpoly)

# Appeler le C:
            a = slot(p1, "coords")
            b = slot(p2, "coords")
            res = 0
            nia = as.integer(nrow(a))
            nib = as.integer(nrow(b))
            ret = .C("DistanceMinimale", as.double(a), as.integer(nia), 
                as.double(b), as.integer(nib), dist = as.double(res),
		 PACKAGE="landm")

            distances[i, j] = ret$dist
 # La matrice est symtrique:
            distances[j ,i] = ret$dist
} # fin j
} # fin i

    return(distances)
} # fin distMin.Polygons


setMethod("distMin", signature(x = "Polygons"), distMin.Polygons)

