# -----------------------------------------------------
# Cration d'un object de la classe "Polygons" du package 'sp'
# (liste de polygones)  partir d'un fichier de polygones 
# en format 1,
# c.a.d, un fichier qui contient:
# - 1iere ligne: le nombre de polys
# - pour chaque poly:
#  * un identificateur numrique, suivi des x-coordonnes
#  * le mme  identificateur numrique, suivi des y-coordonnes
# Les coordonnes doivent tre clockwise si non trou
# et anticlock si trou.
# Le poly peut tre ferm ou non
# Arguments:
# Le pathname du fichier qui contient les coordonnes des polys. 
# Le dlimiteur des valeurs
# Un identificateur de l'objet cr
# Retour:
# un object de la classe "Polygons" du package 'sp'.
# -----------------------------------------------------
readFormat1 <- function(filename, sep=" ", ID=filename) {
# -----------------------------------------------------
  # Lecture de tout le fichier
  lu = readLines(filename)

  npoly = as.integer(lu[1])
  
  retour = list()
  
  k=1
  for (i in 1:npoly) {
    k=k+1
    # Lecture de l'identificateur, et abscisses
    ligne = strsplit(lu[k],sep)[[1]]
    ligne = ligne[ligne !=""]
    id = ligne[1]
    xlu =  as.double(ligne[2:length(ligne)])
    k=k+1
    # Lecture de l'identificateur, et ordonnes
    ligne = strsplit(lu[k],sep)[[1]]
    ligne = ligne[ligne !=""]
    if (ligne[1] != id) {
      stop(paste ("On the lines ", k-1, " and", k,
                  "the identifiers are respect. ", id,
                  " and", ligne[1], "\n"))
    }
    ylu =  as.double(ligne[2:length(ligne)])

# Fermer le poly si ncessaire:
 if ((xlu[length(xlu)] != xlu[1]) ||
 (ylu[length(ylu)] != ylu[1]))
{
xlu=c(xlu, xlu[1])
ylu=c(ylu, ylu[1])
}


    coo = matrix(c(xlu, ylu), ncol=2)
    dimnames(coo) = list(NULL, c("xcoord", "ycoord"))

# Creation du poly 'sp':
polysp = Polygon(coo)

    retour[[id]] = polysp
  } # fin npoly
# Creation du Polygons:
return(Polygons(retour,ID))
}
