\name{inConvex.Polygons}
\alias{inConvex.Polygons}
\title{  Test the relative position of pairs of convex  polygons.}
\description{
Test if convex polygons are included, or contain, or cross,
or are distinct from another one.
}
\usage{
inConvex.Polygons(x, y, digits = 2, maxvertices = 50, notconvex)
}
\arguments{
  \item{x}{ An object of class \code{\link[sp]{Polygons-class}} }
\item{y}{ Ignored }
  \item{digits}{ The number of decimal digits to take into account 
for the coordinates }
  \item{maxvertices}{ The maximal number of vertices per convex
  subpolygon }
\item{notconvex}{ Ignored }
}
\value{
A character matrix where the number of rows and the number of columns
are the number of polygons in \code{x}.
The value of the element [i,j] is a
A character equal to "D" (Distinct),
"I" (Included), "C" (Cross), or "S" (Surround)
whether the polygon j is distinct from, included in, cross,
contains i.

If the polygon i or the polygon j is not convex, NA is returned.
}
\author{  A. Bouvier }
\seealso{ \code{\link{inConvex.Polygon}}}
\examples{
p1=Polygon(cbind(c(1,1,4,4,1), c(1,4,4,1,1)))
p2=Polygon(cbind(c(1.5,1.5,3,3,1.5), c(2,3,3,2,2)))
lp=Polygons(list(p1,p2),"")
plot(lp)
inConvex(lp)
}
\keyword{manip}
\keyword{methods}
