\name{readFormat2}
\alias{readFormat2}
\title{ Create an object of class Polygons of package sp from a file. }
\description{
Create an object of \code{\link[sp]{Polygons-class}} of package sp from coordinates read on a text file.
}
\usage{
readFormat2(filename, sep = "\t", ID = filename)
}
\arguments{
  \item{filename}{ the name of the file which the data are to be read from. }
  \item{sep}{ the field separator character. Values on each line of
  the file are separated by this character. }
  \item{ID}{ value of the slot 'ID' in the created object. }
}
\details{
The file should contain:
- on the first line: the number of polygons,
- then, for each polygon, three lines:
  * an ident (an integer value), a name (a character string),
the number of vertices
  * the x-coordinates,
  * the y-coordinates.
The coordinates should be clockwise if the polygon is not a hole,
and anticlockwise if it is a hole.
The polygon may be closed or not.
}
\value{
 An object of class \code{\link[sp]{Polygons-class} of package sp} 
}
\author{  A. Bouvier }
\seealso{  \code{\link{readFormat2}}}

\examples{
# not run
# Beginning of the file ex-data:
#232
#1	1	4	2.189626
#154.761902	95.238098	178.571426	273.809509
#297.619049	333.333344	571.428589	547.619019
#2	1	4	1.955782
#250.000000	154.761902	273.809509	297.619049
#250.000000	285.714294	547.619019	428.571442
#
#> exnc= readFormat2("tests/ex-nc")
}
\keyword{IO}
\keyword{file}

