/*--------------- COPYRIGHT ------------------------
| INRA - Unité MIA de Jouy en Josas                |
--------------------------------------------------*/
///////////////////////////////////////////////////////

#include <stdio.h>
#include <limits.h>
#include <string.h>
#include <math.h>
#include <float.h>
#include <stdlib.h>


////////////////////////////////////////////////////
// Les fonctions de l'API R
////////////////////////////////////////////////////
extern char * REprintf( char *, ...);
extern char * Rprintf(char *, ...);

////////////////////////////////////////////////////
// Les includes
////////////////////////////////////////////////////
#include "lesdefines.h"
#include "lestypes.h"
#include "lesmacros.h"
#include "geom.h"



/////////////////////////////////////////////
// Arguments d'entree:
// id: un identificateur de poly
// verbose: 1 si verbose
// Ad: matrice des coordonnees du poly
// nia: nbre de sommets du poly
// Arguments de sortie:
// convexi: 1 si convexe
/////////////////////////////////////////////
void
isconvex ( char ** id,
	   int *verbose,
	    double *Ad, int *nia,
	   int *convexi)
{

  int  nsommets = *nia;
  int convex = 0;
  tVertex vertices;

// Initialisation de la liste
  NEW (vertices, tsVertex);
  vertices->next = vertices->prev = vertices;
  vertices->v[XX] = vertices->v[YY] = 0;

      if (*verbose == 1)
	{
	Rprintf ("****************************************\n");
	Rprintf ("Polygon %s (counterclock-wise):\n", *id);
	}
      ReadVertices ( *verbose, nsommets,  Ad,vertices);


      // Découpage en sous-polys convexes
      convex = Convexity (vertices);

      if (*verbose == 1)
	    {
      if (!convex)
	{
	      Rprintf ("polygon %s is nonconvex\n", *id);
	    }
      else
	Rprintf ("polygon is convex\n");

	    } // fin verbose
      *convexi = (int)convex;

}				// fin  isconvex
