#ifndef _LESTYPES_H
#define _LESTYPES_H
/*--------------- COPYRIGHT ------------------------
| INRA - Unit MIA de Jouy en Josas                |
--------------------------------------------------*/

#include "lesdefines.h"

////////////////////////////////////////////////////
// Les types
////////////////////////////////////////////////////
typedef double real;

typedef  int tPointi[DIM];	// Type int point
typedef real tPointd[DIM];
typedef tPointi tPolygoni[PMAX];	// type integer polygon

// Define structures for vertices, edges
typedef struct tVertexStructure tsVertex;
typedef tsVertex *tVertex;

typedef struct tdVertexStructure tdsVertex;
typedef tdsVertex *tdVertex;



struct tVertexStructure
{
  tPointi v;
  int vnum;
  int ear;			// T iff an ear
  tVertex next, prev;
};

struct tdVertexStructure
{
  tPointd v;
  int vnum;
  tdVertex next, prev;
};


typedef struct			// struct for saving diagonals in array
{
  int exist;		// whether diagonal exist (essential/non)
  int vfrom;			// index from vertex of diagonal endpoint
  int convexfrom;		// whether from is convex
  int vto;			// index to vertex of diagonal endpoint
  int convexto;		// whether to is convex
  int dnext;                    // indice de la diag suivante
} DIAGONAL_STRUCT;


typedef struct			// struct for saving vertices as array
{
  long int xv;			// x coordinate
  long int yv;			// y coordinate

} POLYGON_STRUCT;

#endif
